#ifdef GL_HERETIC

//#define __DOOMTYPE__

#include <windows.h>
#include <stdio.h>
#include <math.h>
#include <string.h>
#include <gl/gl.h>
#include <GL/glu.h>
#include "gl_struct.h"
// MD2
#include "md2.h"

#ifndef GL_HEXEN
#include "doomdef.h"
#else
#include "h2def.h"
#endif

extern int *a_iLineArray,*a_iLinePresent;
#ifdef RASTER
extern float fps;
extern long lNbFrames;
extern GLboolean g_bGlobalRaster;
#endif

extern byte *p_bPalette;

extern H_boolean g_bMD2;

#ifdef DOOM_GL
CHAR szAppName[]="DoomGL";
#elif	GL_HEXEN
CHAR szAppName[]="GLHexen";
#else
CHAR szAppName[]="GLHeretic";
#endif
//HWND  ghWnd;
extern HWND  win;
HDC   ghDC;
HGLRC ghRC=0;

GLfloat aspect;

unsigned char doublebuffer=1;

//extern DEVMODE dvmdOrig;
extern int fullscreen;
//void fn_vRestoreScreenResolution();
void fn_vChangeScreenResolution();
void GL_vInitMD2Tables();

extern GLboolean g_bPaletteTexture,g_bSpriteOpti,g_bSpriteBilinear;
extern GLboolean g_bGlobalRaster,g_bDisplayRaster;
extern float fScaleSprite;
extern int iMaxSizeBeforeReduction;
extern float fSpriteFilterDistanceCoeff;

extern int windowActive;
extern H_boolean		grabMouse;
extern H_boolean g_bMlook;

// ----------------------------------------------------------------
// Memory (WIN32 code)
// ----------------------------------------------------------------

HANDLE g_hHeap=NULL,g_hHeapFix=NULL;
char g_cMemMode=FIX;

void fn_vSetMemoryMode(char type)
{
	g_cMemMode=type;
}

void fn_vInitMemory(DWORD dwSize)
{
	if (g_cMemMode==FIX)
		g_hHeapFix=HeapCreate(HEAP_GENERATE_EXCEPTIONS,dwSize,0);
	else
		g_hHeap=HeapCreate(HEAP_GENERATE_EXCEPTIONS,dwSize,0);
}

void fn_vDesinitMemory()
{ HANDLE hHeap=(g_cMemMode==FIX?g_hHeapFix:g_hHeap);

	if (!hHeap)
		return;
	HeapDestroy(hHeap);
	if (g_cMemMode==FIX)
		g_hHeapFix=NULL;
	else
		g_hHeap=NULL;
}

LPVOID GLMalloc(DWORD dwNbBytes)	// Heap
{ LPVOID memory;
  HANDLE hHeap=(g_cMemMode==FIX?g_hHeapFix:g_hHeap);

	//memory=HeapAlloc(g_hHeap,HEAP_GENERATE_EXCEPTIONS,dwNbBytes);
	memory=HeapAlloc(hHeap,0,dwNbBytes);

	return memory;
}

LPVOID GLRealloc(LPVOID lpMem,DWORD dwBytes)
{ LPVOID memory;
  HANDLE hHeap=(g_cMemMode==FIX?g_hHeapFix:g_hHeap);

	if (!lpMem)
	{	printf("Attempt to realloc NULL pointer");
		return FALSE;
	}
	else
	{
		/*if (!HeapValidate(MMHeap,0,NULL))
			TRACE("Connard\n");*/
		//memory=HeapReAlloc(MMHeap,HEAP_GENERATE_EXCEPTIONS,lpMem,dwBytes);
		memory=HeapReAlloc(hHeap,0,lpMem,dwBytes);

		return memory;
	}
}

BOOL GLFree(LPVOID lpMem)
{ HANDLE hHeap=(g_cMemMode==FIX?g_hHeapFix:g_hHeap);
	////return HeapFree(MMHeap,HEAP_NO_SERIALIZE,lpMem);
	return HeapFree(hHeap,0,lpMem);
}

// ----------------------------------------------------------------
// WIN32 code
// ----------------------------------------------------------------
BOOL bSetupPixelFormat(HDC hdc)
{ 
    PIXELFORMATDESCRIPTOR pfd = {
        sizeof(PIXELFORMATDESCRIPTOR),  // size of this pfd
        1,                              // version number
        PFD_DRAW_TO_WINDOW |             // support window
        PFD_SUPPORT_OPENGL |          // support OpenGL
        PFD_DOUBLEBUFFER ,           // double buffered
        PFD_TYPE_RGBA,                  // RGBA type
        16,                             // 16-bit color depth
        0, 0, 0, 0, 0, 0,               // color bits ignored
        0,                              // no alpha buffer
        0,                              // shift bit ignored
        0,                              // no accumulation buffer
        0, 0, 0, 0,                     // accum bits ignored
        32,                             // 16-bit z-buffer      
        0,                              // no stencil buffer
        0,                              // no auxiliary buffer
        PFD_MAIN_PLANE,                 // main layer
        0,                              // reserved
        0, 0, 0                         // layer masks ignored
    };
   
    PIXELFORMATDESCRIPTOR *ppfd=&pfd;
    int pixelformat;
	
    if (doublebuffer)
      ppfd->dwFlags |= PFD_DOUBLEBUFFER;
		
    if ((pixelformat = ChoosePixelFormat(hdc, ppfd)) == 0) 
	  {
        MessageBox(NULL, "ChoosePixelFormat failed", "Error", MB_OK);
        return FALSE;
    }
	
    if (pfd.dwFlags & PFD_NEED_PALETTE) 
	{
        MessageBox(NULL, "Needs palette", "Error", MB_OK);
        return FALSE;
    }
	
    if (SetPixelFormat(hdc, pixelformat, ppfd) == FALSE) 
	{
        MessageBox(NULL, "SetPixelFormat failed", "Error", MB_OK);
        return FALSE;
    }
	
    return TRUE;
}

void OnCreateWindow(HWND hWnd)
{ RECT rect;

	//fullscreen=1;
/*	if (fullscreen)
		fn_vChangeScreenResolution();*/

    ghDC = GetDC(hWnd);
    if (!bSetupPixelFormat(ghDC))
        PostQuitMessage (0);
    ghRC = wglCreateContext(ghDC);
    wglMakeCurrent(ghDC, ghRC);
    GetClientRect(hWnd, &rect);
    initializeGL(rect.right, rect.bottom);
	//DisplayGLInfo();
	/*fn_vCreateWalls();
	fn_vCreateFloorPolygons();
	fn_vCreateCeilingPolygons();
	fn_vCreateSky();*/
}

void OnCloseWindow(HWND hWnd)
{
	ChangeDisplaySettings(0, 0);
    wglMakeCurrent(NULL, NULL);
	if (ghRC)
        wglDeleteContext(ghRC);
    if (ghDC)
        ReleaseDC(hWnd, ghDC);
    ghRC = 0;
    ghDC = 0;
	
    DestroyWindow (hWnd);
}

void OnDestroyWindow(HWND hWnd)
{
    wglMakeCurrent(NULL, NULL);
    if (ghRC)
        wglDeleteContext(ghRC);
    if (ghDC)
        ReleaseDC(hWnd, ghDC);
	
	Free(a_iLineArray);
	Free(a_iLinePresent);

	fn_vSetMemoryMode(LEVEL);
	fn_vDesinitMemory();
	fn_vSetMemoryMode(FIX);
	fn_vDesinitMemory();

#ifdef RASTER
	if (g_bGlobalRaster)	// MR1907
		printf("Average frames per second: %f\n",fps/lNbFrames);
#endif
	//ChangeDisplaySettings(NULL, 0);		// fullscreen off
	//fn_vRestoreScreenResolution();

    PostQuitMessage (0);

	exit(0);
}

extern int TranslateKey(unsigned k);

static LRESULT CALLBACK GLWndProc(HWND hwnd, UINT message,
                                WPARAM wparam, LPARAM lparam)
{
    event_t event;
    //RECT rect;
    
    switch ( message )
    {        
	    case WM_QUIT:
			exit(0);
			break;
	    case WM_CREATE:
			//OnCreateWindow(hwnd);	// MR0309
            break;

		case WM_DESTROY:
			OnDestroyWindow(hwnd);
            break;

		case WM_CLOSE:
			OnCloseWindow(hwnd);
            break;

        case WM_KEYDOWN:
            event.type = ev_keydown;
            event.data1 = TranslateKey(wparam);
            if ( event.data1 != 0 )
#ifndef GL_HEXEN
                D_PostEvent(&event);
#else
				H2_PostEvent(&event);
#endif
            break;

        case WM_KEYUP:
            event.type = ev_keyup;
            event.data1 = TranslateKey(wparam);
            if ( event.data1 != 0 )
#ifndef GL_HEXEN
                D_PostEvent(&event);
#else
				H2_PostEvent(&event);
#endif
            break;            
            
        case WM_ACTIVATE:
			if ( LOWORD(wparam) )
            { RECT rect;

                if ( !windowActive )
                {
                    if ( grabMouse )
                    {
                        ClipCursor(NULL); /* helps with Win95? */
                        GetWindowRect(win, &rect);
                        ClipCursor(&rect);
                        ShowCursor(FALSE);
                    }                    
                }
                windowActive = 1;
            }
            else
            {
                if ( grabMouse )
                {
                    ClipCursor(NULL);
                    ShowCursor(TRUE);
                }
                windowActive = 0;
            }
            return DefWindowProc(hwnd, message, wparam, lparam);

        default:
            return(DefWindowProc(hwnd, message, wparam, lparam));
    }

    return 0;
}

void I_GL_InitGraphics(void)
{
    //MSG msg;
    WNDCLASSEX wndclass;
    HINSTANCE hInstance=(HINSTANCE) GetModuleHandle(NULL);
		
//	InitGL();
//	return;

	// Register the frame class 
    wndclass.cbSize        = sizeof (wndclass);
    wndclass.style         = CS_HREDRAW | CS_VREDRAW | CS_OWNDC;
    wndclass.lpfnWndProc   = (WNDPROC)GLWndProc;
    wndclass.cbClsExtra    = 0;
    wndclass.cbWndExtra    = 0;
    wndclass.hInstance     = hInstance;
    wndclass.hIcon         = LoadIcon (hInstance, szAppName);
    wndclass.hCursor       = LoadCursor (NULL,IDC_ARROW);
    wndclass.hbrBackground = (HBRUSH)(COLOR_WINDOW+1);;
    wndclass.lpszMenuName  = szAppName;
    wndclass.lpszClassName = "GLHereticWindowClass";
	wndclass.hIconSm       = 0;
	
    if (RegisterClassEx(&wndclass))
	{
		//fn_vInitMemory(10000000);
	
		if (fullscreen)
			fn_vChangeScreenResolution();

		win = CreateWindowEx(0,"GLHereticWindowClass", szAppName, 
			/*WS_CAPTION | */WS_POPUP | WS_CLIPSIBLINGS | WS_CLIPCHILDREN,
			0, 0, SCREENWIDTH, SCREENHEIGHT,
			NULL, NULL, hInstance, NULL);
		
		// Make sure window was created 
		if (win)
		{ RECT rect;
			// Show and update main window 
			ShowWindow(win, SW_SHOW);
			UpdateWindow(win);
			OnCreateWindow(win);	// MR009

			GetClientRect(win, &rect);

			ClipCursor(&rect);	// MR
		}
	}
}

// ----------------------------------------------------------------
// OpenGL code
// ----------------------------------------------------------------
GLboolean g_b3Dfx=FALSE;
void DisplayGLInfo()
{
	const unsigned char *vendor=glGetString(GL_VENDOR);
	const unsigned char *version=glGetString(GL_VERSION);
	unsigned char str[1]={0};
	const unsigned char *renderer=glGetString(GL_RENDERER);
	const unsigned char *extension=str;
	//int StencilDepth;

	/* can't be called wglCreateContext with 3dfxfl.dll ????? */
	/*if ( (ghRC!=0) && (strstr((const char *) vendor,"3Dfx")!=NULL) )
	{
		renderer=glGetString(GL_RENDERER);
		extension=glGetString(GL_EXTENSIONS);
	}*/
//	DisplayText("OpenGL v%s (%s) %s %s\n",version,vendor,renderer,extension);
	extension=glGetString(GL_EXTENSIONS);
	printf("OpenGL v%s (%s) %s\n",version,vendor,renderer);
	printf("OpenGL Extensions: %s\n",extension);
	if (!strstr((char *)extension,"GL_EXT_paletted_texture"))
	{	g_bPaletteTexture=FALSE;
		printf("OpenGL driver doesn't support paletted textures\n");
	}
	//if (strstr(version,"3Dfx")||strstr(vendor,"3Dfx")||strstr(renderer,"3Dfx"))
	//	g_b3Dfx=TRUE;
	//glGetIntegerv(GL_STENCIL_BITS,&StencilDepth);
}

GLvoid resize( GLsizei width, GLsizei height )
{
    glViewport(0, 0, width, height);
}    

GLvoid initializeGL(GLsizei width, GLsizei height)
{ // MD2
  int count,i;
  char *toto;

    //GLfloat aspect;
	aspect = (GLfloat)width/(GLfloat)height;

	DisplayGLInfo();
	
	p_bPalette=W_CacheLumpName("PLAYPAL", PU_STATIC);		// DOOM_GL
    
	glClearColor(0.0f, 0.0f, 0.0f, 0.0f);
    glClearDepth(1.0);
    glDepthFunc(GL_LEQUAL);
    glShadeModel(GL_SMOOTH);
	
	// enable 
    glEnable(GL_DEPTH_TEST);
	
    glPixelStorei(GL_UNPACK_ALIGNMENT, 1);

	//fn_vInitGLTextures();
	
    glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);
	//glHint(GL_POLYGON_SMOOTH_HINT, GL_NICEST);
	glHint(GL_POLYGON_SMOOTH_HINT, GL_FASTEST);

	fn_vInitGLTexFonts();

	if (!screen)
		screen=(byte *)malloc(SCREENWIDTH*SCREENHEIGHT*4);

	// MD2 (test)
	if (g_bMD2)
		GL_vInitMD2Tables();
	// End MD2
	GL_fn_vInitLights();
#ifdef WEAP_DRAWPIX
	fn_vAllocWeaponMemory();
#endif
	// MR3006: DynLight (test)
	//GL_AddLightSource(0,0,0,0,0,1,0,0,10.0f);
	
	// Fog...
//	glEnable(GL_FOG);
#ifdef GL_HEXEN
	glFogi(GL_FOG_MODE,GL_LINEAR);
	//glFogi(GL_FOG_MODE,GL_EXP);
    { GLfloat fogColor[4] = {0.5, 0.5, 0.5, 1.0};

      glFogfv (GL_FOG_COLOR, fogColor);
    //  glFogf (GL_FOG_DENSITY, 0.3);
      glFogf (GL_FOG_START, 0.5);
      glFogf (GL_FOG_END, 7.0);
   }
#endif
}

extern H_boolean g_bLightEffects;
void GL_InitCommandLine()
{ int p;

	if (M_CheckParm("-paltex"))
	{	g_bPaletteTexture=TRUE;
		printf("OpenGL: Paletted textures enabled\n");
	}
	//if (M_CheckParm("-sprfilter"))
	{	g_bSpriteBilinear=TRUE;
		printf("OpenGL: Sprite filtering enabled\n");
	}
	//if (M_CheckParm("-sprcompr"))
	{	g_bSpriteOpti=TRUE;
		printf("OpenGL: Sprite compression enabled\n");
	}
	if ((p=M_CheckParm("-sprscale")))
		fScaleSprite=(float)atof(myargv[p+1]);
	if ((p=M_CheckParm("-sprmaxsurf")))
	{	iMaxSizeBeforeReduction=atoi(myargv[p+1]);
		printf("OpenGL: Sprite maximum surface: %d\n",iMaxSizeBeforeReduction);
		printf("OpenGL: Sprite factor scale: %f\n",fScaleSprite);
	}
	if ((p=M_CheckParm("-raster")))
	{	g_bGlobalRaster=TRUE;
	}
	if ((p=M_CheckParm("-dspraster")))
	{	g_bDisplayRaster=TRUE;
	}
	if ((p=M_CheckParm("-3dfx")))
	{	g_b3Dfx=TRUE;
		printf("OpenGL: Max texture size is 256x256\n");
	}
	/*if ((p=M_CheckParm("-filterdist")))
	{	fSpriteFilterDistanceCoeff=(float)atof(myargv[p+1]);
		printf("OpenGL: Sprite filter distance: %f\n",fSpriteFilterDistanceCoeff);
	}*/
    //grabMouse = !!M_CheckParm("-grabmouse");
	grabMouse = 1;
	if ((p=M_CheckParm("-mlook")))
		g_bMlook=TRUE;
	else
		g_bMlook=FALSE;
	
	if (!M_CheckParm("-noeffects"))	// DarkFang
		g_bLightEffects=TRUE;
	else
		g_bLightEffects=FALSE;
}

// *****************************************************************************************************************
#if 0
#include "gldemo.h"

windata_t   WinData;
devinfo_t   DevInfo;
char       *szFSDesc[] = { "Windowed", "Full Screen" };
BOOL             CreateMainWindow( int width, int height, int bpp, BOOL fullscreen);
LRESULT CALLBACK WndProc (HWND, UINT, WPARAM, LPARAM);

//int WINAPI WinMain (HINSTANCE hInstance, HINSTANCE hPrevInstance, PSTR szCmdLine, int iCmdShow)
int InitGL()
   {
    MSG         msg;
    int         i;
    HDC         hdc;
	HINSTANCE hInstance=(HINSTANCE) GetModuleHandle(NULL);

    // Not changable by user
    WinData.hInstance    = hInstance;
    //WinData.iCmdShow     = iCmdShow;
	WinData.iCmdShow     = SW_SHOW;
    WinData.wndproc      = (WNDPROC)WndProc;
    WinData.pResolutions = 0;
    WinData.NearClip     = 2.0f;
    WinData.FarClip      = 512.0f;

    // User definable
    WinData.fov          = 65.0f;
    WinData.bAllowSoft   = TRUE;
    WinData.bFullScreen  = TRUE;

    // Get the current display device info
    hdc = GetDC( NULL );
    DevInfo.bpp    = GetDeviceCaps(hdc, BITSPIXEL);
    DevInfo.width  = GetSystemMetrics(SM_CXSCREEN);
    DevInfo.height = GetSystemMetrics(SM_CYSCREEN);
    ReleaseDC(NULL, hdc);

    // Parse the command line if there is one
    WinData.argc = 0;
    /*if (strlen(szCmdLine) > 0)
       {
        WinData.szCmdLine = szCmdLine;
        GetParameters();
       }*/

    // Default to 640 pixels wide
    if ((i = FindNumParameter("-width")) != -1)
       {
        WinData.width = i;
       }
    else
       {
        WinData.width = 640;
       }

    // Default to 480 pixels high
    if ((i = FindNumParameter("-height")) != -1)
       {
        WinData.height = i;
       }
    else
       {
        WinData.height = 480;
       }

    // Default to 16 bits of color per pixel
    if ((i = FindNumParameter("-bpp")) != -1)
       {
        WinData.bpp = i;
       }
    else
       {
        WinData.bpp = 16;
       }

    // Default to a 65 degree field of view
    if ((i = FindNumParameter("-fov")) != -1)
       {
        WinData.fov = (float)i;
       }
    else
       {
        WinData.fov = 65.0f;
       }

    // Check for windowed rendering
    if (FindParameter("-window"))
       {
        WinData.bFullScreen = FALSE;
       }

    // Build up the video mode list
    BuildModeList();

    // Set the desired video mode and/or color depth
    if (!SetVideoMode())
       {
        Cleanup();
        return 0;
       }

    // Create the main program window, start up OpenGL and create our viewport
    if (CreateMainWindow( WinData.width, WinData.height, WinData.bpp, WinData.bFullScreen) != TRUE)
       {
        ChangeDisplaySettings(0, 0);
        MessageBox(NULL, "Unable to create main window.\nProgram will now end.", "FATAL ERROR", MB_OK);
        Cleanup();
        return 0;
       }

    // Turn the cursor off for full-screen mode
    if (WinData.bFullScreen == TRUE)
       { // Probably want to do this all the time anyway
        ShowCursor(FALSE);
       }

    // Load the demonstration texture
    /*LoadTexture();

    // We're live now
    WinData.bActive = TRUE;

    // Begin the main program loop
    while (WinData.bActive == TRUE)
       {
        while (PeekMessage(&msg, NULL, 0, 0, PM_REMOVE))
           {
            TranslateMessage (&msg);
            DispatchMessage (&msg);
           }
        if (WinData.hGLRC)
           {
            RenderScene();
           }
       }
    if (WinData.bFullScreen == TRUE)
       {
        ShowCursor(TRUE);
       }
    // Release the parameter and video resolution lists
    Cleanup();
    return msg.wParam;*/
   }

void GetParameters()
   {
    int   count;
    char *s, *tstring;

    // Make a copy of the command line to count the parameters - strtok is destructive
    tstring = (char *)malloc(sizeof(char)*(strlen(WinData.szCmdLine)+1));
    strcpy(tstring, WinData.szCmdLine);

    // Count the parameters
    s = strtok(tstring, " ");
    count = 1;
    while (strtok(NULL, " ") != NULL)
       {
        count++;
       }
    free(tstring);

    // Allocate "pockets" for the parameters
    WinData.argv = (char **)malloc(sizeof(char*)*(count+1));

    // Copy first parameter into the "pockets"
    WinData.argc = 0;
    s = strtok(WinData.szCmdLine, " ");
    WinData.argv[WinData.argc] = (char *)malloc(sizeof(char)*(strlen(s)+1));
    strcpy(WinData.argv[WinData.argc], s);
    WinData.argc++;

    // Copy the rest of the parameters
    do
       {
        // get the next token
        s = strtok(NULL, " ");
        if (s != NULL)
           { 
            // add it to the list
            WinData.argv[WinData.argc] = (char *)malloc(sizeof(char)*(strlen(s)+1));
            strcpy(WinData.argv[WinData.argc], s);
            WinData.argc++;
           }
       }
    while (s != NULL);
   }

void Cleanup()
   {
    int i;

    // Free the command line holder memory
    if (WinData.argc > 0)
       {
        // Free in reverse order of allocation
        for (i = (WinData.argc-1); i >= 0; i--)
           {
            free(WinData.argv[i]);
           }
        // Free the parameter "pockets"
        free(WinData.argv);
       }
    // Free the memory that holds the video resolution list
    if (WinData.pResolutions)
        free(WinData.pResolutions);
   }

BOOL isdigits( char *s )
   {
    int i;

    for (i = 0; s[i]; i++)
       {
        if ((s[i] > '9') || (s[i] < '0'))
           {
            return FALSE;
           }
       }
    return TRUE;
   }

int FindNumParameter(char *s)
   {
    int i;

    for (i = 0; i < (WinData.argc-1); i++)
       {
        if (stricmp(WinData.argv[i], s) == 0)
           {
            if (isdigits(WinData.argv[i+1]) == TRUE)
               {
                return(atoi(WinData.argv[i+1]));
               }
            else
               {
                return -1;
               }
           }
       }
     return -1;
   }

BOOL FindParameter(char *s)
   {
    int i;

    for (i = 0; i < WinData.argc; i++)
       {
        if (stricmp(WinData.argv[i], s) == 0)
           {
            return TRUE;
           }
       }
    return FALSE;
   }

BOOL CreateMainWindow(int width, int height, int bpp, BOOL fullscreen)
   {
    HWND        hwnd;
    WNDCLASSEX  wndclass;
    DWORD       dwStyle, dwExStyle;
    int         x, y, sx, sy, ex, ey, ty;

    if ((hwnd = FindWindow(szAppName, szAppName)) != NULL)
       {
        SetForegroundWindow(hwnd);
        return 0;
       }

    wndclass.cbSize        = sizeof (wndclass);
    wndclass.style         = CS_HREDRAW | CS_VREDRAW | CS_OWNDC;
    wndclass.lpfnWndProc   = (WNDPROC)WinData.wndproc;
    wndclass.cbClsExtra    = 0;
    wndclass.cbWndExtra    = 0;
    wndclass.hInstance     = WinData.hInstance;
    wndclass.hIcon         = 0;
    wndclass.hCursor       = LoadCursor (NULL, IDC_ARROW);
    wndclass.hbrBackground = (HBRUSH)(COLOR_WINDOW+1);
    wndclass.lpszMenuName  = NULL;
    wndclass.lpszClassName = szAppName;
    wndclass.hIconSm       = 0;


    if (!RegisterClassEx (&wndclass))
       {
        MessageBox(NULL, "Window class registration failed.", "FATAL ERROR", MB_OK);
        return FALSE;
       }

    if (fullscreen)
       {
        dwExStyle = WS_EX_TOPMOST;
        dwStyle = WS_POPUP | WS_VISIBLE;
        x = y = 0;
        sx = WinData.width;
        sy = WinData.height;
       }
    else
       {
        dwExStyle = 0;
        //dwStyle = WS_CAPTION | WS_SYSMENU | WS_THICKFRAME;  // Use this if you want a "normal" window
        dwStyle = WS_CAPTION;
        ex = GetSystemMetrics(SM_CXEDGE);
        ey = GetSystemMetrics(SM_CYEDGE);
        ty = GetSystemMetrics(SM_CYSIZE);
        // Center the window on the screen
        x = (DevInfo.width / 2) - ((WinData.width+(2*ex)) / 2);
        y = (DevInfo.height / 2) - ((WinData.height+(2*ey)+ty) / 2);
        sx = WinData.width+(2*ex);
        sy = WinData.height+(2*ey)+ty;
        /*
           Check to be sure the requested window size fits on the screen and
           adjust each dimension to fit if the requested size does not fit.
        */
        if (sx >= DevInfo.width)
           {
            x = 0;
            sx = DevInfo.width-(2*ex);
           }
        if (sy >= DevInfo.height)
           {
            y = 0;
            sy = DevInfo.height-((2*ey)+ty);
           }
       }

    if ((hwnd = CreateWindowEx (dwExStyle,
                    szAppName,               // window class name
		            szAppName,                // window caption
                    dwStyle | WS_CLIPCHILDREN | WS_CLIPSIBLINGS, // window style
                    x,           // initial x position
                    y,           // initial y position
                    sx,           // initial x size
                    sy,           // initial y size
                    NULL,                    // parent window handle
                    NULL,                    // window menu handle
                    WinData.hInstance,       // program instance handle
		            NULL))                   // creation parameters
                    == NULL)
        {
         ChangeDisplaySettings(0, 0);
         MessageBox(NULL, "Window creation failed.", "FATAL ERROR", MB_OK);
         return FALSE;
        }

    WinData.hWnd = hwnd;
	win=hwnd;

    if (!InitOpenGL())
       {
        WinData.hWnd = NULL;
        return FALSE;
       }

    ShowWindow(WinData.hWnd, WinData.iCmdShow);
    UpdateWindow(WinData.hWnd);

    SetForegroundWindow(WinData.hWnd);
    SetFocus(WinData.hWnd);

    return TRUE;
   }


LRESULT CALLBACK WndProc (HWND hwnd, UINT iMsg, WPARAM wParam, LPARAM lParam)
   {
    switch (iMsg)
       {
        case WM_CHAR:
             switch(wParam)
                {
                 case VK_ESCAPE:
                      SendMessage(hwnd, WM_CLOSE, 0, 0);
                      break;
                }
             break;

        case WM_ACTIVATE:
             if ((LOWORD(wParam) != WA_INACTIVE) && ((HWND)lParam == NULL))
                {
                 ShowWindow(WinData.hWnd, SW_RESTORE);
                 SetForegroundWindow(WinData.hWnd);
                }
             else
                {
                 if (WinData.bFullScreen)
                    {
                     ShowWindow(WinData.hWnd, SW_MINIMIZE);
                    }
                }
             return 0;

        case WM_SIZE:
             if (WinData.hGLRC)
                {
                 // Redefine the viewing volume and viewport when the window size changes.
                 WinData.glnWidth = (GLsizei)LOWORD(lParam);
                 WinData.glnHeight = (GLsizei)HIWORD(lParam);
                 WinData.gldAspect = (float)((GLdouble)WinData.glnWidth/(GLdouble)WinData.glnHeight);
                 glViewport( 0, 0, WinData.glnWidth, WinData.glnHeight );
                }
             return 0;

        case WM_CLOSE:
             ShutdownOpenGL();
             WinData.bActive = FALSE;
             break;

        case WM_DESTROY:
             PostQuitMessage (0);
             return 0;
       }

    return DefWindowProc (hwnd, iMsg, wParam, lParam);
   }

// This function builds a list the screen resolutions supported by the display driver
void BuildModeList()
   {
    DEVMODE  dm;
    int      mode;

    mode = 0;
    while(EnumDisplaySettings(NULL, mode, &dm))
       {
        mode++;
       }

    WinData.pResolutions = (screen_res_t *)malloc(sizeof(screen_res_t)*mode);
    mode = 0;
    while(EnumDisplaySettings(NULL, mode, &dm))
       {
        WinData.pResolutions[mode].width = dm.dmPelsWidth;
        WinData.pResolutions[mode].height = dm.dmPelsHeight;
        WinData.pResolutions[mode].bpp = dm.dmBitsPerPel;
        WinData.pResolutions[mode].flags = dm.dmDisplayFlags;
        WinData.pResolutions[mode].frequency = dm.dmDisplayFrequency;
        mode++;
       }
    WinData.iResCount = mode;
   }

BOOL SetVideoMode()
   {
    OSVERSIONINFO   vinfo;
    int             mode;
    DEVMODE         dm;

    vinfo.dwOSVersionInfoSize = sizeof(vinfo);

    WinData.bChangeBPP = FALSE;

    if ( GetVersionEx( &vinfo) )
       {
        if ( vinfo.dwMajorVersion > 4 )
           {
            WinData.bChangeBPP = TRUE;
           }
        else
        if ( vinfo.dwMajorVersion == 4 )
           {
            if ( vinfo.dwPlatformId == VER_PLATFORM_WIN32_NT )
               {
                WinData.bChangeBPP = TRUE;
               }
            else
            if ( vinfo.dwPlatformId == VER_PLATFORM_WIN32_WINDOWS )
               {
                if ( LOWORD( vinfo.dwBuildNumber ) >= OSR2_BUILD_NUMBER )
                   {
                    WinData.bChangeBPP = TRUE;
                   }
               }
           }
       }
    else
       {
        MessageBox(NULL, "SetVideoMode - GetVersionEx failed\n", "FATAL ERROR", MB_OK);
        return FALSE;
       }

    if (WinData.bFullScreen)
       {
        if ((WinData.bpp    == DevInfo.bpp) &&
            (WinData.width  == DevInfo.width) &&
            (WinData.height == DevInfo.height))
           {
            WinData.iVidMode = 0;
            return TRUE;
           }
        if ((WinData.bChangeBPP == FALSE) && (DevInfo.bpp != WinData.bpp))
           {
            MessageBox(NULL, "This version of Windows cannot change color depth.\n"
                             "Please request different video mode settings or adjust\n"
                             "your desktop color depth.", "FATAL ERROR", MB_OK);
            return FALSE;
           }
        for (mode = 0; mode < WinData.iResCount; mode++)
           {
            if ((WinData.pResolutions[mode].width == WinData.width) &&
                (WinData.pResolutions[mode].height == WinData.height) &&
                (WinData.pResolutions[mode].bpp == WinData.bpp))
               {
                WinData.iVidMode = mode;

                memset(&dm, 0, sizeof(dm));
                dm.dmSize = sizeof(dm);

                dm.dmPelsWidth  = WinData.width;
                dm.dmPelsHeight = WinData.height;
                dm.dmFields     = DM_PELSWIDTH | DM_PELSHEIGHT;

                if (WinData.bpp != DevInfo.bpp)
                   {
                    dm.dmBitsPerPel = WinData.bpp;
                    dm.dmFields |= DM_BITSPERPEL;
                   }

                if ( ChangeDisplaySettings( &dm, CDS_FULLSCREEN ) != DISP_CHANGE_SUCCESSFUL )
                   {
                    MessageBox(NULL, "SetVideoMode - ChangeDisplaySettings failed.\n"
                                     "Switching to windowed mode.", "WARNING", MB_OK);
                    WinData.bFullScreen = FALSE;
                    return TRUE;
                   }
                return TRUE;
               }
           }
        MessageBox(NULL, "Your requested video mode is unavailable.\n"
                         "Please request different video mode settings.", "FATAL ERROR", MB_OK);
        return FALSE;
       }
    else
       {
        if (DevInfo.bpp != WinData.bpp)
           {
            MessageBox(NULL, "Your requested color depth and desktop do not match.\n"
                             "Using your current desktop color depth.", "WARNING", MB_OK);
           }
       }
    return TRUE;
   }

BOOL InitOpenGL()
   {
    int     pfm;   // pixel format
    RECT    rect;

    PIXELFORMATDESCRIPTOR pfd = 
        {
         sizeof(PIXELFORMATDESCRIPTOR),  // size of this pfd
                1,                       // version number
                PFD_DRAW_TO_WINDOW |     // support window
                PFD_SUPPORT_OPENGL |     // support OpenGL
                PFD_DOUBLEBUFFER,        // double buffered
                PFD_TYPE_RGBA,           // RGBA type
                24,                      // 24-bit color depth
                0, 0, 0, 0, 0, 0,        // color bits ignored
                0,                       // no alpha buffer
                0,                       // shift bit ignored
                0,                       // no accumulation buffer
                0, 0, 0, 0,              // accum bits ignored
                32,                      // 32-bit z-buffer      
                0,                       // no stencil buffer
                0,                       // no auxiliary buffer
                PFD_MAIN_PLANE,          // main layer
                0,                       // reserved
                0, 0, 0                  // layer masks ignored
        };
    if ((WinData.hDC = GetDC(WinData.hWnd)) == NULL)
       {
        ChangeDisplaySettings(0, 0);
        MessageBox(NULL, "GetDC on main window failed", "FATAL ERROR", MB_OK);
        return FALSE;
       }

    if ((pfm = ChoosePixelFormat(WinData.hDC, &pfd)) == 0)
       {
        ChangeDisplaySettings(0, 0);
        MessageBox(NULL, "ChoosePixelFormat failed\n", "FATAL ERROR", MB_OK);
        return FALSE;
       }
    if (SetPixelFormat(WinData.hDC, pfm, &pfd) == FALSE)
       {
        ChangeDisplaySettings(0, 0);
        MessageBox(NULL, "SetPixelFormat failed\n", "FATAL ERROR", MB_OK);
        return FALSE;
       }
    DescribePixelFormat(WinData.hDC, pfm, sizeof(pfd), &pfd);

    if (!(pfd.dwFlags & PFD_GENERIC_ACCELERATED)) // Incorrectly reported on most drivers I've tested
       {
        if (WinData.bAllowSoft == FALSE)
           {
            ChangeDisplaySettings(0, 0);
            MessageBox(NULL, "OpenGL Driver is not accelerated\n", "FATAL ERROR", MB_OK);
            return FALSE;
           }
       }

    if ((WinData.hGLRC = wglCreateContext(WinData.hDC)) == 0)
       {
        ChangeDisplaySettings(0, 0);
        MessageBox(NULL, "wglCreateContext failed\n", "FATAL ERROR", MB_OK);
        goto fail;
       }

    if (!wglMakeCurrent(WinData.hDC, WinData.hGLRC))
       {
        ChangeDisplaySettings(0, 0);
        MessageBox(NULL, "wglMakeCurrent failed\n", "FATAL ERROR", MB_OK);
        goto fail;
       }

    GetClientRect(WinData.hWnd, &rect);
    WinData.glnWidth= rect.right;
    WinData.glnHeight = rect.bottom;
    WinData.gldAspect = (float)((GLdouble)WinData.glnWidth/(GLdouble)WinData.glnHeight);

    glEnable(GL_TEXTURE_2D);
    glEnable(GL_POLYGON_SMOOTH);
    glEnable(GL_DEPTH_TEST);
    glDepthFunc(GL_LEQUAL);

    glClearColor( 0.0f, 0.0f, 0.0f, 1.0f );

    return TRUE;

fail:
    if ( WinData.hGLRC )
       {
        wglDeleteContext( WinData.hGLRC);
        WinData.hGLRC = NULL;
       }

    if ( WinData.hDC )
       {
        ReleaseDC(WinData.hWnd, WinData.hDC);
        WinData.hDC = NULL;
       }
    return FALSE;
   }

    
void ShutdownOpenGL(void)
   {
    if (WinData.hGLRC)
       {
        if ((!wglMakeCurrent(NULL, NULL)) && (!WinData.bFullScreen))
           {
            MessageBox(NULL, "ShutdownOpenGL - wglMakeCurrent failed\n", "ERROR", MB_OK);
           }
        if (!wglDeleteContext(WinData.hGLRC))
           {
            MessageBox(NULL, "ShutdownOpenGL - wglDeleteContext failed\n", "ERROR", MB_OK);
           }
        WinData.hGLRC = NULL;
       }
    if (WinData.hDC)
       {
        if (!ReleaseDC(WinData.hWnd, WinData.hDC))
           {
            MessageBox(NULL, "ShutdownOpenGL - ReleaseDC failed\n", "ERROR", MB_OK);
           }
        WinData.hDC   = NULL;
       }
    if (WinData.bFullScreen)
       {
        ChangeDisplaySettings( 0, 0 );
       }
   }
#endif	// 0

#endif // GL_HERETIC